
// simple text match filter

define(['../filter', 'utils'], function(Filter, Utils){

	var regex = null;

	return new Filter({
		name: 'text',
		fn: function(item){
			return (!regex || item.title_().match(regex) || item.name().match(regex) || item.keywords().match(regex));
		},
		on_change: function(a, val){
			this.text = val;
			regex = new RegExp(Utils.escape_regex(val), 'i');
			this.events.send('changed');
		},
		//TODO we need this method? set empty value instead?
		deactivate: function() {
			this.text = '';
			regex = null;
			this.events.send('changed');
		},
		status: function(){ return this.text; },
		text: null
	});

});
