define(['config', 'jquery', 'bus', 'ajax_queue'], function(ECMWF, $, Bus, Ajaxqueue){

$.fn.productManager = function(args){

	var o = $.extend({
		bus: Bus()
	}, args || {});

	return $(this).each(function() {

		var types = ['product', 'projection', 'layer'];
		for(var t in types) add_listener();

		function add_listener(){
			var kind = types[t];

			o.bus
				.listen(kind + '-thumbnail-delete', function(_, msg){
					msg.type = kind;

					Ajaxqueue({
						url: '/backend/delete-from-user-space/',
						priority: "very-high",
						json: msg,
						success: function(result){
							o.bus.send(kind + "-removed-from-catalogue", result)
						},
						error: function(result){
							$.logError(kind + " delete failed.");
						}
					});
				})

				.listen(kind + "-thumbnail-edit", function(_, msg){
					ECMWF.dialogue({
						title: "Edition options  ...",
						items: [{
							type: "string",
							name: "title",
							value: msg.title,
							title: "Name"
						}, {
							type: "text",
							name: "description",
							value: msg.description,
							title: "Description"
						}, {
							type: "text",
							name: "keywords",
							value: msg.keywords,
							title: "Keywords"
						}],
						ok: function(choices){
							choices.type = kind;
							choices.name = msg.name;
							Ajaxqueue({
								url: '/backend/modify-information',
								priority: "very-high",
								json: choices,
								success: function(result){
									o.bus.send(kind + "-modified-info", result)
								}
							});
						}
					});
				});
		}
	});
};

});
